using Telerik.TestingFramework.Controls.KendoUI;
using Telerik.WebAii.Controls.Html;
using Telerik.WebAii.Controls.Xaml;
using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;
using System.Xml;
using System.Xml.Linq;

using ArtOfTest.Common.UnitTesting;
using ArtOfTest.WebAii.Core;
using ArtOfTest.WebAii.Controls.HtmlControls;
using ArtOfTest.WebAii.Controls.HtmlControls.HtmlAsserts;
using ArtOfTest.WebAii.Design;
using ArtOfTest.WebAii.Design.Execution;
using ArtOfTest.WebAii.ObjectModel;
using ArtOfTest.WebAii.Silverlight;
using ArtOfTest.WebAii.Silverlight.UI;

namespace TestProject6
{

    //
    // You can add custom execution steps by simply
    // adding a void function and decorating it with the [CodedStep] 
    // attribute to the test method. 
    // Those steps will automatically show up in the test steps on save.
    //
    // The BaseWebAiiTest exposes all key objects that you can use
    // to access the current testcase context. [i.e. ActiveBrowser, Find ..etc]
    //
    // Data driven tests can use the Data[columnIndex] or Data["columnName"] 
    // to access data for a specific data iteration.
    //
    // Example:
    //
    // [CodedStep("MyCustom Step Description")]
    // public void MyCustomStep()
    // {
    //        // Custom code goes here
    //      ActiveBrowser.NavigateTo("http://www.google.com");
    //
    //        // Or
    //        ActiveBrowser.NavigateTo(Data["url"]);
    // }
    //
        

    public class WebTest : BaseWebAiiTest
    {
        #region [ Dynamic Pages Reference ]

        private Pages _pages;

        /// <summary>
        /// Gets the Pages object that has references
        /// to all the elements, frames or regions
        /// in this project.
        /// </summary>
        public Pages Pages
        {
            get
            {
                if (_pages == null)
                {
                    _pages = new Pages(Manager.Current);
                }
                return _pages;
            }
        }

        #endregion
        
        // Add your test methods here...
        public void SaveValue(string iterationText) 
        { 
            string path = @"C:\IterationValue.xml"; 
            XElement e = new XElement("IterationValue"); 
            e.Add(new XElement("iteration", iterationText)); 
            e.Save(path); 
        } 


        public string LoadValue()
        {
            string path = @"C:\IterationValue.xml";
            XElement e = XElement.Load(path);
            string iterationText = e.Element("iteration").Value;
            return iterationText;
        }
    
        [CodedStep(@"Enter text 'Telerik' in 'GbqfqText'")]
        public void WebTest_CodedStep()
        {
            string currentIteration = Data["Col1"].ToString();            
            string previousIteration = LoadValue();
            
            //Check whether text for the current iteration is the same as the text for the previous iteration 
            if (currentIteration != previousIteration)
            {
                //Enter the text from the current iteration
                Actions.SetText(Pages.Google.GbqfqText, currentIteration);
            }
            else
            {
                //Enter empty string
                Actions.SetText(Pages.Google.GbqfqText, String.Empty);
            }
        }
    
        [CodedStep(@"New Coded Step")]
        public void WebTest_CodedStep1()
        {
            string previousIteration = Data["Col1"].ToString();
            SaveValue(previousIteration);
        }
    }
}
